<?php
namespace Teknisa\FAI\Modules\Parametros\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;

use \Zeedhi\Framework\DataSource\DataSet;
use \Zeedhi\Framework\DataSource\FilterCriteria;
use \Zeedhi\Framework\DataSource\Manager;
use \Zeedhi\Framework\DataSource\ParameterBag;

class Fai05100ItemGrupoClientesParaFaturamento extends \Teknisa\GER\Controllers\TeknisaCrud {
  protected $crudService;
  protected $parameterBag;
  protected $entityManager;
  protected $environment;
  protected $dataSourceManager;
  protected $util;
  protected $newCode;
  protected $connection;
  protected $novoCodigo;
  
  public function __construct($crudService, ParameterBag $parameterBag, $environment, $entityManager, $dataSourceManager, $util, $newCode, $connection, $novoCodigo) {
    parent::__construct($crudService, $parameterBag);
    $this->crudService = $crudService;
    $this->entityManager = $entityManager;
    $this->environment = $environment;
    $this->dataSourceManager = $dataSourceManager;
    $this->util = $util;
    $this->newCode = $newCode;
    $this->connection = $connection;    
    $this->novoCodigo = $novoCodigo;
  }
  
    public function salvarCliente(DTO\Request $request, DTO\Response $response) {
      try {
        $this->connection->beginTransaction();
        $this->dataSourceName = 'itgrupcliefat';
        $this->parameterBagColumns = array();
        
        $rows = $this->crudService->getRowsToSave($request, $this->dataSourceName);
        foreach($rows as $row) {
  			  if(!$row["__is_new"]) {
    			  $row["DTINCLUSAO"] = substr($row["DTINCLUSAO"], 0, 10);
    			  $row["DTULTATU"] = substr($row["DTULTATU"], 0, 10);
  			  } else {
  			    $row["NRITGRUPCLIEFAT"] = intval($this->novoCodigo->getCodeByTableName('ITGRUPCLIEFAT', $row['NRORG']));
  			  }  
  			  $row["CDFILIALSERV"] = "";
  				$this->crudService->save($this->dataSourceName, array($row));
  				
  				$this->connection->commit();
        }
      } catch(\Exception $e) {
  			$response->addDataSet(new DataSet("errorInfo", array("erroSalvarCliente" => $e->getMessage())));
  			$response->setError(new Error("erroSalvarCliente", 500));      
      }
  }
}